<template>
  <div>
    <button
      class="flat_btn flat_btn-icon"
      @click="visible=!visible">
      <TheClock
        :width="36"
        :progress="progress"></TheClock>
    </button>
    <div
      class="champions_timer"
      v-show="visible">
      <div class="champions_timer_header">{{$t('champions.timer')}}</div>
      <div class="champions_timer_body">
        <TheCounter :timestamp="type==='day' ? intraDayLeft : intraMonthLeft"></TheCounter>
      </div>
      <div class="champions_timer_footer">
        <Btn
          @click="visible=false"
          transparent
          style="margin:0px; height: 40px; width: calc(100% - 30px);">OK
        </Btn>
      </div>
    </div>
  </div>
</template>

<script>
  import TheClock from '~/components/UI/ProgressCircle/TheClock';
  import Btn from '~/components/UI/BtnSign_plain';
  import BtnDark from '~/components/UI/BtnSign_dark';
  import TheCounter from './TheCounter';


  export default {
    name: "TheTimer",
    props: {
      type: {
        type: String
      }
    },
    data() {
      return {
        visible: false,
        actualTime: new Date(),
        secondsInDay: 24 * 60 * 60
      }
    },
    components: {
      TheClock,
      Btn,
      BtnDark,
      TheCounter
    },
    computed: {
      endOfDay() {
        return new Date(Date.UTC(this.actualTime.getUTCFullYear(), this.actualTime.getUTCMonth(), this.actualTime.getUTCDate() + 1, 0, 0, 0));
      },
      endOfMonth() {
        return new Date(Date.UTC(this.actualTime.getUTCFullYear(), this.actualTime.getUTCMonth() + 1, 0, 0, 0, 0));
      },
      intraDayLeft() {
        return Math.floor(this.endOfDay.getTime() - this.actualTime.getTime()) / 1000;
      },
      intraMonthLeft() {
        return Math.floor(this.endOfMonth.getTime() - this.actualTime.getTime()) / 1000;
      },
      secondsInMonth() {
        return new Date(Date.UTC(this.actualTime.getUTCFullYear(), this.actualTime.getUTCMonth(), 0)).getUTCDate() * 24 * 60 * 60;
      },
      progress() {
        if (this.type === 'day') {
          return (this.secondsInDay - this.intraDayLeft) / this.secondsInDay * 100
        } else {
          return (this.secondsInMonth - this.intraMonthLeft) / this.secondsInMonth * 100
        }
      }
    },
    methods: {},
    mounted() {
      setInterval(_ => {
        this.actualTime = new Date();
      }, 1000);
    }
  }
</script>
<style
  lang="scss"
  scoped>
  .champions_timer {
    position: absolute;
    left: 10px;
    min-width: calc(100% - 20px);
    z-index: 1;
    top: 63px;
    border: 1px solid #3f475a;
    border-radius: 10px;
    overflow: hidden;
    box-shadow: 0px 0px 10px 0px rgba(0, 0, 0, 0.4);
    &_header {
      padding: 10px 20px;
      font-size: .725rem;
      color: #ffffff;
      background-color: #222b3e;
    }
    &_body {
      background-color: #2b354a;
    }
    &_footer {
      background-color: #222b3e;
      padding: 10px 0px;
    }
  }
</style>
